<?php

if(!defined('VALID_ENTRY_POINT')){
    header('Location: index.php');
    exit;
}

session_start();


// Active tous les warning. Utile en phase de dveloppement
// En phase de production, remplacer E_ALL par 0
error_reporting(E_ALL);

// Inclusions diverses
include_once('./includes/config.php');
include_once('./includes/template.php');
include_once './includes/mes-fonctions.php';

// Gestionnaire d'erreurs
set_exception_handler('exception_handler');


// Objet de base de donnes
$db = new PDO(DB_CONNECTION_STRING, DB_USER, DB_PASSWORD);


// Template actuel
$desired_template_id = NULL;
if(!empty($_GET['tpl']) and is_numeric($_GET['tpl'])){
    $desired_template_id = intval($_GET['tpl']);
}
else{
    if(empty($_SESSION['current_template'])){
        $desired_template_id = DEFAULT_TEMPLATE_ID;
    }
}

if($desired_template_id){
    $sql = 'SELECT Id, Nom, Repertoire
            FROM gabarits
            WHERE Id = :id_gabarit';

    $statement = $db->prepare($sql);
    $statement->execute(array(':id_gabarit' => $desired_template_id));
    if(!($gabarit = $statement->fetch()) or !is_dir(TEMPLATES_ROOT_FOLDER.'/'.$gabarit['Repertoire'])){
        $statement->execute(array(':id_gabarit' => DEFAULT_TEMPLATE_ID));
        $gabarit = $statement->fetch();
    }
    $_SESSION['current_template'] = $gabarit['Repertoire'];
}

// Thme actuel
$desired_theme_id = NULL;
if(!empty($_GET['theme']) and is_numeric($_GET['theme'])){
    $desired_theme_id = intval($_GET['theme']);
}
else{
    if(empty($_SESSION['current_theme'])){
        $desired_theme_id = DEFAULT_THEME_ID;
    }
}

if($desired_theme_id){
    $sql = 'SELECT Id, Nom, Repertoire
            FROM themes
            WHERE Id = :id_theme';

    $statement = $db->prepare($sql);
    $statement->execute(array(':id_theme' => $desired_theme_id));
    if(!($theme = $statement->fetch()) or !is_dir(THEMES_ROOT_FOLDER.'/'.$theme['Repertoire'])){
        $statement->execute(array(':id_theme' => DEFAULT_THEME_ID));
        $theme = $statement->fetch();
    }
    $_SESSION['current_theme'] = $theme['Repertoire'];
}


// Langue actuelle
$desired_lang_id = NULL;
if(!empty($_GET['lang']) and is_numeric($_GET['lang'])){
    $desired_lang_id = intval($_GET['lang']);
}
else{
    if(empty($_SESSION['language_id']) or empty($_SESSION['language_short'])){
        $desired_lang_id = DEFAULT_LANG_ID;
    }
}

if($desired_lang_id){
    $sql = 'SELECT Id, Nom, Diminutif
            FROM langues
            WHERE Id = :id_langue';

    $statement = $db->prepare($sql);
    $statement->execute(array(':id_langue' => $desired_lang_id));

    if(!($langue = $statement->fetch()) or !is_file(LANGUAGES_ROOT_FOLDER.'/'.$langue['Diminutif'].'.php')){
        $statement->execute(array(':id_langue' => DEFAULT_LANG_ID));
        $langue = $statement->fetch();
    }
    $_SESSION['language_id'] = $langue['Id'];
    $_SESSION['language_short'] = $langue['Diminutif'];
}
include_once(LANGUAGES_ROOT_FOLDER.'/'.$_SESSION['language_short'].'.php');
$statement = NULL;

$template = new Template(TEMPLATES_ROOT_FOLDER . $_SESSION['current_template']);

?>